diff -u -urN sunix_2.6/driver/sunix.c sunix_2.6-te/driver/sunix.c
--- sunix_2.6/driver/sunix.c	2005-12-30 04:34:14.000000000 +0100
+++ sunix_2.6-te/driver/sunix.c	2006-11-10 10:11:24.000000000 +0100
@@ -1266,7 +1266,7 @@
 	unsigned long			flag;
 #endif
 	
-	recv_room = tty->ldisc.receive_room(tty);
+	recv_room = tty->receive_room;
 
      	if ( (recv_room == 0) && (!info->ldisc_stop_rx)  ) {
     		sunix_throttle(tty);
@@ -1277,8 +1277,8 @@
 	spin_lock_irqsave(&info->slock, flag);
 #endif
 
-  	cp = tty->flip.char_buf;
-  	fp = tty->flip.flag_buf;
+//  	cp = tty->flip.char_buf;
+//  	fp = tty->flip.flag_buf;
         count = 0;	
 
 	if ( iir == UART_IIR_RLSI ) 
@@ -1304,9 +1304,11 @@
 					}	
 				}		
 
-			*cp++ = ch;
- 			*fp++ = 0;
+//			*cp++ = ch;
+// 			*fp++ = 0;
+			tty_insert_flip_char(tty, ch, 0);
 			count++;
+
 END_SWF:
 			if ( (iir == UART_IIR_RDI) && (count < 15) )
 				lsr = 0x01;
@@ -1362,7 +1364,8 @@
 
 RECE_END:	
 	if( count > 0)	
-		tty->ldisc.receive_buf(tty, tty->flip.char_buf, tty->flip.flag_buf, count);
+//		tty->ldisc.receive_buf(tty, tty->flip.char_buf, tty->flip.flag_buf, count);
+		tty_flip_buffer_push(tty);
 #if (LINUX_VERSION_CODE < KERNEL_VERSION(2,6,11))	
 	spin_unlock_irqrestore(&info->slock,flag);
 #endif
